//: attrOLView.cpp
//////////////////////////////////////////////////////////////////////////////

#include "attrOLView.h"
#include "myItem.h"
#include "hexprint.h"

//#define PP(XXX) {printf("--- %d ---\n", XXX);}
#define PP(XXX) {}   // nothing

AttrOLView::AttrOLView(BRect rect)
 :	MyOLView(rect), _refSet()
{
	SetFont(be_fixed_font);

	// BStringView puts white when deselected, so must use
	// White background for now. 
	SetViewColor(245,245,245);
	
	// stuff for hexprint
	hex_compression = true;  // compression is on as a default 
	offset_print = true;     // print offsets by default 
	offset = 0L;             // default start offset for printing 
	fmt_offset = HEXO;       // printf format for offsets 
	fmt_dump = ZHEXD;        // printf format for the dump 
	fmt_pad = HEXP;          // printf format for the dump 
	h_slen = H_SLEN;

}


AttrOLView::~AttrOLView()
{
	DeleteAllAndMakeEmpty();
}


void AttrOLView::SetRefs(BMessage refSet)
{
	_refSet = refSet;
}


void AttrOLView::Refresh()
{
	BAlert 	  *	alert=0;
	BNode  		node;	
	BEntry 		entry;	
	entry_ref     ref;
	attr_info 	ainfo;
	long 		count=0;
	type_code 	type;
	BStringItem *	fileItem=0;

	BAutolock autolocker(Window()); 
 	if ( !autolocker.IsLocked() ) 
 		return;

	const 		ATTRDATA_BUFSIZE = 32768;  // 2^15
	uint8 	  *	attrData = new uint8[ATTRDATA_BUFSIZE];  
	char 		attrName[B_ATTR_NAME_LENGTH];
	char 		fileName[4096]="";
	
	
	DeleteAllAndMakeEmpty();
	
	/*
	AddItem(new MyStringItem(
		//  VAL_START_POS (39).   ........................   .   *
		"\2b(\2D'TYPE'-SIZE\2b)\2f--NAME------------------\2b:\2p--VALUE---"
		"------------------------------------------------------------------"
		"------------------------------------------------------------------"
		"------------------------------------------------------------------"
		"------------------------------------------------------------------", 
		1) );
	*/

	AddItem( new MyStringItem(
		//  VAL_START_POS (39).   ........................   .   *
		"\2b(\2D'TYPE' SIZE\2b)\2f  NAME                  \2b:\2p  VALUE",
		1) );
	
		
	bool traverse = !(modifiers() &  // DON'T traverse link if modifier
					(B_SHIFT_KEY | B_CONTROL_KEY | B_OPTION_KEY));
    	

	_refSet.GetInfo("refs", &type, &count); 	    	
	for ( long ii=0; ii<count; ii++ ) 
	{ 
		if ( _refSet.FindRef("refs", ii, &ref) == B_OK )  
		{ 
			if ( entry.SetTo(&ref, false) == B_OK )
				entry.GetName(fileName);
			else
				strcpy(fileName, "<< BAD ENTRY >>");


			AddItem(fileItem = 
				new TitleItem(fileName, CurLevel(), true));
			
PP(4)	

			EnterSubLevel();

			entry.SetTo(&ref, traverse); 
			if ( node.SetTo(&entry) == B_OK ) 
			{                 
				node.RewindAttrs();
				while (node.GetNextAttrName(attrName) == B_OK)
				{
					node.GetAttrInfo(attrName, &ainfo);
PP(41)	
	
/*
static char typeChars[6]="";
*((uint32*)typeChars)=ainfo.type;
typeChars[4]='\0';
//printf("'%s' \n", typeChars);
//printf("\n'%s'  %s  %d  <-- %s \n", typeChars, attrName, (int32)ainfo.size, fileName);
//*/
	
					if (ainfo.size>0 && node.ReadAttr(
							attrName, ainfo.type, 0, 
							attrData, ATTRDATA_BUFSIZE-1) != ainfo.size)
						// Happens if too big, need to fix...
						return;  
PP(42)	
					attrData[min_c(ainfo.size,ATTRDATA_BUFSIZE-1)] 
						= '\0';  // null terminate if string, JIK!
PP(43)	
//printf("Handling '%s' %s... ", typeChars, attrName); fflush(stdout);							
					HandleTypedData(
						attrData, ainfo.size, ainfo.type, attrName);
//puts(" DONE!\n");
PP(44)	
				}
				
			}
			else  // node didn't work
			{
				AddItem( new MyStringItem(
					"\2bFILE NOT FOUND\2p   (with symlinks traversed)", 
					CurLevel(), true));
			}

			LeaveSubLevel();

			// because BOutlineListView is buggy!
			Collapse(fileItem);  
			Expand(fileItem);
			
			Window()->Unlock();
			// let window update!
			Window()->Lock();
		} 
		else 
		{
			// This is really bad programming... 
			
			alert = new BAlert("alert", 
			"Error finding a File. Sorry.", "Cancel");
			alert->Go();
			return;
		}

		fileName[0] = '\0';		
	}
PP(10)	

	delete [] attrData;
//puts("------------------------------------------------------------");

}



