//: attrOLView.h
//////////////////////////////////////////////////////////////////////////////


#if !defined(H__ATTROLVIEW_H)
#define      H__ATTROLVIEW_H

#include "myOLView.h"

class AttrOLView : public MyOLView 
{
public:
	 AttrOLView(BRect rect);
	~AttrOLView();

	void SetRefs(BMessage refSet);
	virtual void Refresh();


	void AddAttrString(
		type_code     type, 
		size_t        size,
		const char  * name,
		const char  * value);

	void HandleTypedData(
		const void  * data, 
		size_t        datalen,
		type_code     type,
		const char  * name,
		type_code     origType=0);
	
	bool TypeCodeToString(
		type_code     type_, 
		char        * buf_,
		bool          prettify=true);
	
	void DoRaw(const void * data, size_t datalen);

	void Hexprint(const char *data, size_t datalen);



private:

	BMessage _refSet;	
	
	
	// stuff for hexprint
	bool    hex_compression ;  // compression is on as a default 
	bool    offset_print;      // print offsets by default 
	long    offset;            // default start offset for printing 
	char  * fmt_offset;        // printf format for offsets 
	char  * fmt_dump;          // printf format for the dump 
	char  * fmt_pad;           // printf format for the dump 
	int     h_slen;

	
};



class TypeNamePair
{
	const type_code         _type;
	const char   * const    _name;
	
public:
	TypeNamePair(type_code type, const char * name) 
	 :	_type(type), _name(name)  {};
	 
	type_code    Type() {return _type;};
	const char * Name() {return _name;};
	
	bool IsType(type_code type) {return _type == type;};
};

extern TypeNamePair typeNames[];




#endif    // H__ATTROLVIEW_H