//: myItem.h
//////////////////////////////////////////////////////////////////////////////

#if !defined(H__MYITEM_H)
#define      H__MYITEM_H

#include <ListItem.h>
#include <Bitmap.h>


class MyStringItem : public BStringItem
{
public:
	 MyStringItem(
	 	const char *text, uint32 outlineLevel=0, bool expanded=true);
	~MyStringItem();
	
	virtual void  DrawItem(BView *owner, BRect frame, bool complete=false);
	virtual void  Update(BView *owner, const BFont *font);
	const   char* FmtText()  {return _fmtText;};
	                          // has the special format codes as passed in
	                          // Text() will give string w/ no codes.

private:
	float _ascent;      // Top to baseline
	float _totalHeight; 
	float _totalWidth;
	char * _fmtText;      // text, w/ format codes.

#define MSI_FORMAT_CODE_BYTE ((uint8) '\2')
#define MSI_FMT(xXx) "\2" #xXx   

};




class ImageItem : public BListItem
{
public:
	 ImageItem(
	 	float width,
	 	float height,
	 	color_space mode,
	 	const void * data,
	 	uint32 outlineLevel = 0,
	 	bool expanded = true);
	 	
	~ImageItem();
	
	
	virtual void DrawItem(
		BView *owner,
		BRect bounds,
		bool complete = false);
	
	virtual void Update(BView *owner, const BFont *font);
	
	
private:
	BBitmap * _bitmap;	
	float _width;
	float _height;
};



class TitleItem : public BStringItem
{
public:
	 TitleItem(const char *text, uint32 outlineLevel=0, bool expanded=true);
	~TitleItem();
	
	virtual void DrawItem(BView *owner, BRect frame, bool complete=false);
	virtual void Update(BView *owner, const BFont *font);

private:
	font_height _fontHt;
};



#endif    // H__MYITEM_H

