//: myWindow.cpp
//////////////////////////////////////////////////////////////////////////////


#include "myWindow.h"
#include "attrOLView.h"
#include "addOnControl.h"


MyWindow::MyWindow(BRect rect, const char* title)
 :	BWindow(rect, title, B_DOCUMENT_WINDOW, 0),
 	_mainView(0), _scrollView(0)
{
	_menuBar = new BMenuBar(BRect(0,0,1,1), "MenuBar");
	BMenu * menu = 0;
	
	menu = new BMenu("View");
	DoMenuItem(menu, "Refresh", MENU_refresh);
	DoMenuItem(menu, "Collapse All", MENU_collapseAll);  
	DoMenuItem(menu, "Expand All", MENU_expandAll);    
	_menuBar->AddItem(new BMenuItem(menu));	

	
	// Edit isn't implemented yet 
	
	//menu =  new BMenu("Edit");
	//DoMenuItem(menu, "Copy Full Line", MENU_copyLine);
	//DoMenuItem(menu, "Copy Value", MENU_copyValue);  
	//_menuBar->AddItem(new BMenuItem(menu));	


	AddChild(_menuBar);
	BRect mrect = _menuBar->Bounds();
		

	rect.OffsetTo(B_ORIGIN);
	rect.top  = mrect.bottom+1;
	rect.left = 0;
	rect.right  -= B_V_SCROLL_BAR_WIDTH;
	rect.bottom -= B_H_SCROLL_BAR_HEIGHT;
	
	_mainView = new AttrOLView(rect);
		
	_scrollView = new BScrollView (
		"ScrollView", _mainView, 
		B_FOLLOW_ALL, B_WILL_DRAW, true, true,
		B_PLAIN_BORDER );
	
	// not required, but the scroll view is messed somehow...
	_mainView->TargetedByScrollView(_scrollView);
	
	AddChild(_scrollView);
}


MyWindow::~MyWindow()
{
}


void MyWindow::SetRefs(BMessage refSet)
{
	_mainView->SetRefs(refSet);
}


void MyWindow::RefreshData()
{
	_mainView->Refresh();
}

void MyWindow::DoMenuItem(BMenu * menu, const char * label, uint32 key)
{
	BMessage * msg = new BMessage(MY_MENU_ITEM_SELECTED); 
	msg->AddInt32("key", key);
	
	menu->AddItem(new BMenuItem(label, msg));   
}

bool MyWindow::QuitRequested()
{
	#if (! ADD_ON_NOT_APP) 
		be_app->PostMessage(B_QUIT_REQUESTED);
	#endif

	return(TRUE);
}

void MyWindow::MessageReceived(BMessage *msg)
{
	//char array[10]="";
	//*((int32*)array) =  msg->what;
	//array[4]=0;
	
	switch(msg->what)
	{	
	  case MY_MENU_ITEM_SELECTED:
	  {
		_mainView->MessageReceived(msg);
	  } break;
	
	  default:
		inherited::MessageReceived(msg);
	}
}

