//: myWindow.h
//////////////////////////////////////////////////////////////////////////////

#if !defined(H__MYWINDOW_H)
#define      H__MYWINDOW_H

#include <Window.h>
#include <Rect.h>
#include <View.h>
#include <Menu.h>
#include <ScrollView.h>


class AttrOLView; 



class MyWindow : public BWindow
{
public:
	 MyWindow(BRect rect, const char* title);
	~MyWindow();

	void SetRefs(BMessage refSet);
	void RefreshData();
	
	virtual bool QuitRequested();
	virtual void MessageReceived(BMessage *msg);
	
	enum MenuKeys 
	{	MENU_refresh,
		MENU_collapseAll,
		MENU_expandAll,
		MENU_copyLine,
		MENU_copyValue
	};
	
	static void DoMenuItem(BMenu * menu, const char * label, uint32 key);

	
private:
	BScrollView      * _scrollView;	
	AttrOLView       * _mainView;	
	BMenuBar         * _menuBar;
 //	BFont              _fnFont;
};


const MY_MENU_ITEM_SELECTED = 'mMIS';
const VAL_START_POS = 39;




#endif   // H__MYWINDOW_H 